; ***********************************************************
; *       ( ) *
; ***********************************************************  
; *   :              AVR Studio v.4.13       *
; *  :                     ATmega8(V)              *
; *   :                                    *
; *    PC0,PC1,PC2,PC3,PD4,PD5,PD6,PD7 -                    *
; *         A,B,C,D,E,F,G,H                 * 
; *    PB3,PB4,PB5 -  / X0,X1,X2  *
; *    ADC4 -                        *
; *    PD0,PD1,PD2 -    SB1,SB2,SB3   *
; *    PB1  -                            *
; *   : 4  ( )                *
; *  Fuse-:                                             *
; *    CKSEL    = 0001    BODEN  =  0     CKOPT     = 0     *
; *    SUT      =   10    EESAVE =  0     RSTDISBL  = 1     *
; *    BODLEVEL =    0    WDTON  =  1                       *
; *    CKOUT    =    1    SPIEN  =  0                       *
; *                                       kotov_ig@mail.ru  *
; ***********************************************************

;                 flag
; 0 -     /    (1/0)
; 1 -    /     (1/0)
; 2 -    /  (1/0)
; 3 -    /  (1/0)
; 4 -   /  (1/0)
; 5 -    /  (1/0)
; 6 -    /  (1/0)
; 7 -   /  (1/0)

;                 picter
;  0 -       
;  1 -   
;  2 -   
;  3 -   
;  4 -   
;  5 -   
;  6 -   
;  7 -    
;  8 -    
;  9 -     
; 10 -   
; 11 -    
; 12 -    
; 13 -    
; 14 -      
; 15 -      
; 16 -    

;            umod
; x000zzzz : x -  , zzzz -  

;           indcon
; 0 - /  0 (1/0)  
; 1 - /  1 (1/0)
; 2 - /  2 (1/0)
; 3 - /   0 (1/0)
; 4 - /   1 (1/0)
; 5 - /   2 (1/0)
; 6 -    4  
; 7 -    2  

; (kfh:kfl/512)*uhi:ulo (kfh:kfl = 1-1024)

	     .nolist
        .include "m8def.inc"
         .list

    .equ  POV    = PB1
	.equ  PORTIO = PORTB
	.equ  DDRIO  = PORTIO-1

    .equ  X0     = PB3   ;  / 0
    .equ  X1     = PB4   ;  / 1
    .equ  X2     = PB5   ;  / 2

    .def  zero   = R0    ; 
    .def  evrg   = R1    ; 
    .def  umod   = R2    ; 
	.def  con    = R3    ;   
    .def  uh     = R4    ;  
	.def  ul     = R5    ;  
	.def  dtlo   = R6    ;  
	.def  dthi   = R7    ;  
    .def  uexl   = R8    ;    
    .def  uexh   = R9    ;    
    .def  sumlo  = R10   ;    
    .def  sumhi  = R11   ;   
	.def  delind = R12   ;   
    .def  taskn  = R13   ; 
	.def  kfl    = R14   ;   
	.def  kfh    = R15   ;   
    .def  temp   = R16   ;   
    .def  temp1  = R17 
    .def  temp2  = R18 
    .def  temp3  = R19 
    .def  buton  = R20   ;  
    .def  flag   = R21   ;  
    .def  picter = R22   ; 
    .def  wait   = R23   ;      
    .def  wrdlo  = R24   ;  
    .def  wrdhi  = R25   ;  
    .def  ulo    = R26   ;    
	.def  uhi    = R27   ;    
    .def  dello  = R28   ;  
	.def  delhi  = R29   ;  
   ; ZH:ZL -     

    #define __COMMON_CATHODE__
  #ifdef __COMMON_CATHODE__
	#define  SEG_A  1<<0;0
	#define  SEG_B  1<<1;2
	#define  SEG_C  1<<2;4
	#define  SEG_D  1<<3;7
	#define  SEG_E  1<<4;6
	#define  SEG_F  1<<5;1
	#define  SEG_G  1<<6;3
	#define  SEG_H  1<<7;5
  #else
	#define  SEG_A  ~(1<<0)
	#define  SEG_B  ~(1<<1)
	#define  SEG_C  ~(1<<2)
	#define  SEG_D  ~(1<<3)
	#define  SEG_E  ~(1<<4)
	#define  SEG_F  ~(1<<5)
	#define  SEG_G  ~(1<<6)
	#define  SEG_H  ~(1<<7)
  #endif

           .dseg
	   .org  SRAM_START
       ; 
	 ocrl   :  .byte  1  ;  
	 ocrh   :  .byte  1  ;  
	 tmrl   :  .byte  1  ;   
	 tmrh   :  .byte  1  ;   
	 fsave  :  .byte  1  ;   
	 offcnt :  .byte  1  ;   
	 locnt  :  .byte  1  ;      
	 hicnt  :  .byte  1  ;     
	 imcnt  :  .byte  1  ;   
	 uots   :  .byte  1  ;  
	 prs0lo :  .byte  1  ;   0  
	 prs0hi :  .byte  1  ;   0  
     prs1   :  .byte  1  ;   1 
	 prs2lo :  .byte  1  ;   2  
     prs2hi :  .byte  1  ;   2  
	 implo  :  .byte  1  ;   
     imphi  :  .byte  1  ;   
	 poslo  :  .byte  1  ;   
	 poshi  :  .byte  1  ;    
	 ind0   :  .byte  1  ; 0  
	 ind1   :  .byte  1  ; 1  
	 ind2   :  .byte  1  ; 2  
	 indcon :  .byte  1  ;  
	 blncon :  .byte  1  ;   
     btcnt  :  .byte  1  ;   
	 btlst  :  .byte  1  ;   
     btfnlo :  .byte  1  ;    
     btfnhi :  .byte  1  ;    
     	
          .eseg 
	     .org 0x80
  
    _uh    : .db   0x0A,0x0A,0x0A,0x0A  ;   10+220
    _ul    : .db   0xAA,0xAA,0xAA,0xAA  ;   170
    _dtl   : .db   0x05,0x05,0x05,0x05  ;    5
    _dth   : .db   0x00,0x00,0x00,0x00  ;    
    _kul   : .db   0x00,0x00,0x00,0x00  ;   
    _kuh   : .db   0x01,0x01,0x01,0x01  ;   
    _umod  : .db   0x03,0x03,0x03,0x03  ;  
	_uexl  : .db   0x00,0x00,0x00,0x00  ;   
    _uexh  : .db   0x00,0x00,0x00,0x00  ;   
    _offcnt: .db   0x00,0x00,0x00,0x00  ;   
	_locnt : .db   0x00,0x00,0x00,0x00  ;    
    _hicnt : .db   0x00,0x00,0x00,0x00  ;    
	_tmrl  : .db   0x00,0x00,0x00,0x00  ;    
    _tmrh  : .db   0x00,0x00,0x00,0x00  ;    
	_ocrl  : .db   0xE1,0xE1,0xE1,0xE1  ;   0x4E1 = 1249
    _ocrh  : .db   0x04,0x04,0x04,0x04  ;  
         
		 .cseg
		 .org 0

     rjmp  start
     rjmp  0 ;rjmp  service_INT0 ;  0  
     rjmp  0 ;rjmp  service_INT1 ;  1    
     rjmp  service_OC2  ; TCNT2  OCR2
     rjmp  service_OVF2 ; TCNT2       
     rjmp  0 ;rjmp  service_ICP1 ;  ICP1           
     rjmp  service_OC1A ; TCNT1  OCR1A 
     rjmp  0 ;rjmp  service_OC1B ; TCNT1  OCR1B  
     rjmp  0 ;rjmp  service_OVF1 ; TCNT1       
     rjmp  service_OVF0 ; TCNT0       
     rjmp  0 ;rjmp  service_SPI  ;   SPI  
     rjmp  0 ;rjmp  service_URXC ;   USART 
     rjmp  0 ;rjmp  service_UDRE ; UDR  USART    
     rjmp  0 ;rjmp  service_UTXC ;   USART    
     rjmp  service_ADCC ;            
     rjmp  0 ;rjmp  service_ERDY ;   EEPROM 
     rjmp  0 ;rjmp  service_ACI  ;    
     rjmp  0 ;rjmp  service_TWI  ;   TWI   
     rjmp  0 ;rjmp  service_SPMR ;  spm  

start:
     ldi   temp,high(RAMEND)  ; 
     out   SPH,temp
     ldi   temp,low(RAMEND)
     out   SPL,temp
	   
     clr   zero               ;   SRAM
     ldi   ZH,high(SRAM_START)
     ldi   ZL,low(SRAM_START)
     ldi   YH,high(SRAM_SIZE)
     ldi   YL,low(SRAM_SIZE)
     st    Z+,zero
     sbiw  YH:YL,1
     brne  PC-2

     out   PORTB,zero
	 out   PORTC,zero
     out   PORTD,zero
	 ldi   temp,0b00111010
	 out   DDRB,temp
	 ldi   temp,0b00001111
	 out   DDRC,temp
	 ldi   temp,0b11110000
	 out   DDRD,temp
     ldi   temp,0b00000111
	 out   PORTD,temp

	 ldi   wrdhi,high(_locnt)  
     ldi   wrdlo,low(_locnt)   
	 rcall ee_read_check
	 sts   locnt,temp
	 ldi   wrdhi,high(_hicnt)  
     ldi   wrdlo,low(_hicnt)   
	 rcall ee_read_check
	 sts   hicnt,temp

	 ldi   wrdhi,high(_tmrl)  
     ldi   wrdlo,low(_tmrl)   
	 rcall ee_read_check
	 mov   dtlo,temp
	 ldi   wrdhi,high(_tmrh)  
     ldi   wrdlo,low(_tmrh)   
	 rcall ee_read_check
	 mov   dthi,temp
	 sbr   flag,1<<7
	 push  dtlo
	 or    dtlo,dthi
	 pop   dtlo
	 brne  PC+2
	 clr   flag 

     ldi   temp,(1<<CS22)|(1<<CS21)
     out   TCCR2,temp      ;CTC, F/256 = 8000000/256 = 31250 
	 ldi   temp,177        ;FOC2 = 31250/52 = 601  
     out   TCNT2,temp  
     ldi   temp,182        
     out   OCR2,temp  
    
	 ldi   temp,high(simbol2) ;    
	 sts   poshi,temp         ;    
     ldi   temp,low(simbol2)
	 sts   poslo,temp
	       
     ldi   wrdhi,high(200) 
     ldi   wrdlo,low(200)
	 ldi   temp,50
	 sbic  PIND,0
     rjmp  PC+3
	 cpse  temp,zero
	 dec   temp
	 sbiw  wrdhi:wrdlo,1
	 brne  PC-5
	 tst   temp
	 brne  PC+2
     rjmp  goto2

	 ldi   wrdhi,high(_offcnt)  
     ldi   wrdlo,low(_offcnt)   
	 rcall ee_read_check
	 cpi   temp,99
	 breq  PC+2
	 inc   temp
	 sts   offcnt,temp
	 ldi   wrdhi,high(_offcnt)  
     ldi   wrdlo,low(_offcnt)   
     rcall ee_write_check

	 sbrc  flag,7
	 rjmp  goto3
     rjmp  goto1

goto1:
     .include "no1.asm"  ; 
goto2:
     .include "no2.asm"  ;
goto3:
     .include "no3.asm"  ; 

dummy:
     ret
     
ee_write_check:
     ldi   temp1,4      
wc1: sbic  EECR,EEWE    
     rjmp  wc1
     out   EEARH,wrdhi 
     out   EEARL,wrdlo 
     out   EEDR,temp    
     sbi   EECR,EEMWE   
     sbi   EECR,EEWE    
     adiw  wrdlo,1      
     dec   temp1       
     brne  wc1
     ret

ee_read_check:
     set               
     rcall read_byte   
     in    temp,EEDR  
     rcall read_byte  
     in    temp1,EEDR 
     rcall read_byte   
     in    temp2,EEDR 
     rcall read_byte  
     in    temp3,EEDR  
     sbiw  wrdlo,4    
     push  temp        
     and   temp,temp1 
     and   temp,temp2
     and   temp,temp3
     cp    temp,temp1
     pop   temp        
     brne  rc1         
     clt               
     ret              
rc1: cp    temp,temp1 
     brne  rc2         
     push  temp
     rjmp  rc7
rc2: cp    temp,temp2  
     brne  rc3         
     push  temp
     rjmp  rc7
rc3: cp    temp,temp3  
     brne  rc4         
     push  temp
     rjmp  rc7
rc4: cp    temp1,temp2 
     brne  rc5         
     push  temp1
     rjmp  rc7
rc5: cp    temp1,temp3 
     brne  rc6         
     push  temp1
     rjmp  rc7
rc6: cpse  temp2,temp3 
     ret               
     push  temp2
rc7: pop   temp        
     rcall ee_write_check 
     clt             
     ret	       

read_byte:
     sbic  EECR,EEWE   
     rjmp  read_byte
     out   EEARH,wrdhi 
     out   EEARL,wrdlo
     adiw  wrdlo,1     
     sbi   EECR,EERE  
     ret

service_OVF0:  
     push  temp
     in    temp,SREG
     push  temp
	 push  temp1
	 lds   temp,prs0lo
	 lds   temp1,prs0hi
	 subi  temp,1
	 sbci  temp1,0
     sts   prs0lo,temp
     sts   prs0hi,temp1
     or    temp,temp1
	 brne  se2
	 ldi   temp,255
	 in    temp1,ADCL
     sts   prs0lo,temp
	 sts   prs0hi,temp1
	 sbis  PORTIO,POV
     rjmp  se1
	 cbi   PORTIO,POV
	 rjmp  se2
se1: lds   temp,indcon
	 sbrs  temp,0
     sbi   PORTIO,POV
se2: pop   temp1
     pop   temp
     out   SREG,temp
     pop   temp
     reti 


service_ADCC:
     push  temp
     in    temp,SREG
     push  temp
	 push  temp1
	 push  temp2
	 push  wrdlo
	 push  wrdhi
     in    temp,ADCL
     in    temp1,ADCH  
	 lsr   temp1
	 ror   temp
	 subi  temp,low(256)
     sbci  temp1,high(256)
	 sbrs  temp1,0
     rjmp  ad0
	 com   temp
	 com   temp1
     subi  temp,low(-1)
     sbci  temp1,high(-1)
ad0: add   sumlo,temp
     adc   sumhi,temp1
     inc   evrg
	 rcall u_imp
     ldi   temp,128
	 clc
	 ror   temp
     cpse  evrg,temp
     rjmp  ad2
     clr   evrg
	 lsr   sumhi
     ror   sumlo
	 lsr   sumhi
     ror   sumlo
	 lsr   sumhi
     ror   sumlo
     adc   sumlo,zero
	 adc   sumlo,zero
  	 movw  temp,sumlo
ad1: clr   sumlo
     clr   sumhi
     mov   ulo,temp
	 mov   uhi,temp1
     rcall cor_volt
     sbrc  flag,4
     rjmp  ad2
     rcall volt_comper
     rcall volt_ust
ad2: pop   wrdhi
     pop   wrdlo
     pop   temp2
     pop   temp1
     pop   temp
     out   SREG,temp
     pop   temp
	 reti

 
service_OC1A:
     sbrc  flag,7
	 rjmp  delay
     push  temp
     ldi   temp,(1<<ADEN)|(1<<ADIE)|(1<<ADSC)|(1<<ADPS2) ;8000/32 = 512kHz
     out   ADCSRA,temp
     pop   temp
     reti 
delay:
     push  temp
     in    temp,SREG
     push  temp
	 push  wrdlo
	 push  wrdhi
     lds   temp,prs1
	 ldi   wrdlo,0b00001000
	 sbrc  temp,0
	 clr   wrdlo
	 sts   indcon,wrdlo
	 inc   temp
	 cpi   temp,120
	 breq  dn1
	 sts   prs1,temp
	 rjmp  dn3
dn1: sts   prs1,zero
	 movw  wrdlo,dtlo
	 push  wrdlo
     or    wrdlo,wrdhi
	 pop   wrdlo
	 breq  dn2
	 sbiw  wrdhi:wrdlo,1
	 movw  dtlo,wrdlo
     brne  dn3
dn2: ldi   temp,10
	 sts   ind0,temp
     sts   ind1,temp
  	 sts   ind2,temp
	 sts   indcon,zero
	 clr   flag
	 ldi   temp,high(RAMEND)  
     out   SPH,temp
     ldi   temp,low(RAMEND)
     out   SPL,temp
	 rjmp  goto1
dn3: pop   wrdhi
	 pop   wrdlo
	 pop   temp
     out   SREG,temp
     pop   temp
     reti

service_OC2: 
     reti


service_OVF2:
     push  temp
     in    temp,SREG
     push  temp
	 push  temp1
	 push  temp2
	 push  ZH
	 push  ZL
	 ldi   temp,178
	 out   TCNT2,temp
     lds   temp,prs2lo
	 inc   temp
	 sts   prs2lo,temp
     cpi   temp,50
     brne  oc1
	 sts   prs2lo,zero
	 lds   temp,prs2hi
	 inc   temp
     sts   prs2hi,temp
oc1: lds   ZL,poslo
	 lds   ZH,poshi
     icall
oc2: pop   ZL
	 pop   ZH
	 pop   temp2
	 pop   temp1
     pop   temp
     out   SREG,temp
     pop   temp
     reti   
	 
simbol2:
     lds   temp,ind2
     rcall convert
     lds   temp,indcon
     push  temp3
     lds   temp3,prs2hi
  #ifdef __COMMON_CATHODE__
     sbrc  temp,5
     sbr   temp2,SEG_H
     sbrs  temp,2
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+3
     clr   temp1
     clr   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     clr   temp1
     clr   temp2
  #else
     sbrc  temp,5
     cbr   temp2,SEG_H
     sbrs  temp,2
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+4
     ser   temp1
     ser   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     ser   temp1
     ser   temp2
  #endif
     pop   temp3
  #ifdef __COMMON_CATHODE__
     sbi   PORTB,X0
     sbi   PORTB,X1
  #else
     cbi   PORTB,X0
     cbi   PORTB,X1
  #endif
     andi  temp1,0b00001111
     andi  temp2,0b11110000
     ori   temp2,0b00000111
     out   PORTC,temp1
	 out   PORTD,temp2
  #ifdef __COMMON_CATHODE__
     cbi   PORTB,X2
  #else
     sbi   PORTB,X2
  #endif
     ldi   temp,high(simbol1) 
	 sts   poshi,temp         
     ldi   temp,low(simbol1)
	 sts   poslo,temp
     reti

simbol1:
     lds   temp,ind1
     rcall convert
     lds   temp,indcon
     push  temp3
     lds   temp3,prs2hi
  #ifdef __COMMON_CATHODE__
     sbrc  temp,4
     sbr   temp2,SEG_H
     sbrs  temp,1
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+3
     clr   temp1
     clr   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     clr   temp1
     clr   temp2
  #else
     sbrc  temp,4
     cbr   temp2,SEG_H
     sbrs  temp,1
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+4
     ser   temp1
     ser   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     ser   temp1
     ser   temp2
  #endif
     pop   temp3
  #ifdef __COMMON_CATHODE__
     sbi   PORTB,X0
     sbi   PORTB,X2
  #else
     cbi   PORTB,X0
     cbi   PORTB,X2
  #endif
     andi  temp1,0b00001111
     andi  temp2,0b11110000
     ori   temp2,0b00000111
     out   PORTC,temp1
	 out   PORTD,temp2
  #ifdef __COMMON_CATHODE__
     cbi   PORTB,X1
  #else
     sbi   PORTB,X1
  #endif
     ldi   temp,high(simbol0) 
	 sts   poshi,temp         
     ldi   temp,low(simbol0)
	 sts   poslo,temp
     reti

simbol0:
     lds   temp,ind0
     rcall convert
     lds   temp,indcon
     push  temp3
     lds   temp3,prs2hi
  #ifdef __COMMON_CATHODE__
     sbrc  temp,3
     sbr   temp2,SEG_H
     sbrs  temp,0
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+3
     clr   temp1
     clr   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     clr   temp1
     clr   temp2
  #else
     sbrc  temp,3
     cbr   temp2,SEG_H
     sbrs  temp,0
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+4
     ser   temp1
     ser   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     ser   temp1
     ser   temp2
  #endif
     pop   temp3
  #ifdef __COMMON_CATHODE__
     sbi   PORTB,X1
     sbi   PORTB,X2
  #else
     cbi   PORTB,X1
     cbi   PORTB,X2
  #endif
     andi  temp1,0b00001111
     andi  temp2,0b11110000
     ori   temp2,0b00000111
     out   PORTC,temp1
	 out   PORTD,temp2
  #ifdef __COMMON_CATHODE__
     cbi   PORTB,X0
  #else
     sbi   PORTB,X0
  #endif
     ldi   temp,high(button) 
	 sts   poshi,temp        
     ldi   temp,low(button)
	 sts   poslo,temp
     reti

button:
  #ifdef __COMMON_CATHODE__
     sbi   PORTB,X2
     sbi   PORTB,X1
     sbi   PORTB,X0
  #else
     cbi   PORTB,X2
     cbi   PORTB,X1
     cbi   PORTB,X0
  #endif
     rcall press_btn  
	 lds   ZH,btfnhi         
	 lds   ZL,btfnlo
     icall
     ldi   temp,high(simbol2) 
	 sts   poshi,temp         
     ldi   temp,low(simbol2)
	 sts   poslo,temp
     ret

press_btn:
     rcall btn_polling
	 mov   buton,temp2
	 tst   buton
	 brne  pr1
     sts   btlst,zero
	 sts   btcnt,zero 
	 clr   buton
     ret
pr1: lds   temp,btlst
	 cp    buton,temp
     sts   btlst,buton
	 breq  pr2
	 sts   btcnt,zero 
	 clr   buton
     ret
pr2: lds   temp,btcnt
     inc   temp
	 sts   btcnt,temp
     cpi   temp,70
     brne  pr4
     subi  temp,4
	 sts   btcnt,temp
     cpi   buton,1
	 brne  PC+2
pr3: clr   buton
     ret
pr4: cpi   temp,4
     brne  pr3
     ret

btn_polling:
     clr   temp2 
     in    temp,PIND
     com   temp
     cbr   temp,0b11111000
     cpi   temp,0b00000001
     brne  PC+3
     ldi   temp2,1
     ret
     cpi   temp,0b00000010
     brne  PC+3
     ldi   temp2,2
     ret
     cpi   temp,0b00000100
     brne  PC+2
     ldi   temp2,3
     ret  

u_imp:
     push  wrdlo
	 push  wrdhi
	 lds   wrdlo,implo
     lds   wrdhi,imphi
     add   wrdlo,temp
	 adc   wrdhi,temp1
     sts   implo,wrdlo
	 sts   imphi,wrdhi
	 lds   temp2,imcnt
	 inc   temp2
	 sts   imcnt,temp2
	 cpi   temp2,4
	 brne  ui2
	 sts   imcnt,zero
	 push  temp1
     clr   temp2       ; uhi:ulo > uh+220,  C=1 
     ldi   temp1,220
     add   temp1,uh
	 rol   temp2
     lsr   wrdhi
	 ror   wrdlo
	 lsr   wrdhi
	 ror   wrdlo
     cp    temp1,wrdlo
     cpc   temp2,wrdhi
     pop   temp1
	 brcs  ui1
	 sts   imphi,zero
	 sts   implo,zero
	 rjmp  ui2
ui1: sbr   flag,1<<2
ui2: pop   wrdhi
	 pop   wrdlo
     ret

volt_comper:
     mov  temp,umod
	 cbr  temp,0b11110000
	 cpi  temp,1
	 breq umod1
     cpi  temp,2
	 breq umod2
	 cpi  temp,3
	 breq umod3
 	 cpi  temp,4
     breq PC+2
	 rjmp umod5
	 rjmp umod4

umod1:                 ; - 1   - 1
     cbr   flag,1<<2
     rcall comp_low
	 brcc  u11
     ldi   temp,50
	 cbr   flag,1<<5 ;  
	 sbr   flag,1<<6
	 movw  uexl,ulo
	 rjmp  u13
u11: rcall comp_hi
	 brcc  u12
     ldi   temp,50
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 movw  uexl,ulo
     rjmp  u13
u12: clr   con
	 cbr   flag,1<<0
	 cbr   flag,(1<<5)|(1<<6)
	 ret
u13: inc   con
     cp    temp,con
     brcc  u14
	 dec   con
	 sbr   flag,1<<0
	 sts   fsave,flag
     ret
u14: cbr   flag,(1<<5)|(1<<6)
     ret

umod2:                 ; - 0   - 1
     cbr   flag,1<<2
     rcall comp_low
	 brcc  u21
     ldi   temp,50
	 cbr   flag,1<<5 ;  
	 sbr   flag,1<<6
	 movw  uexl,ulo
	 rjmp  u23
u21: rcall comp_hi
	 brcc  u22
     ldi   temp,0
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 movw  uexl,ulo
     rjmp  u23
u22: clr   con
	 cbr   flag,1<<0
	 cbr   flag,(1<<5)|(1<<6)
	 ret
u23: inc   con
     cp    temp,con
     brcc  u24
	 dec   con
	 sbr   flag,1<<0
	 sts   fsave,flag
     ret
u24: cbr   flag,(1<<5)|(1<<6)
     ret

umod3:                 ; - 0   - 0  
     cbr   flag,1<<2
     rcall comp_low
	 brcc  u31
     ldi   temp,0
	 cbr   flag,1<<5 ;  
	 sbr   flag,1<<6
	 movw  uexl,ulo
	 rjmp  u33
u31: rcall comp_hi
	 brcc  u32
     ldi   temp,0
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 movw  uexl,ulo
     rjmp  u33
u32: clr   con
	 cbr   flag,1<<0
	 cbr   flag,(1<<5)|(1<<6)
	 ret
u33: inc   con
     cp    temp,con
     brcc  u34
	 clr   con
	 sbr   flag,1<<0
	 sts   fsave,flag
     ret
u34: cbr   flag,(1<<5)|(1<<6)
     ret

umod4:                 ; - 0   - 1,   
     lds   temp,uots
	 tst   temp
	 brne  PC+3
     cbr   flag,1<<3
     rjmp  u4
	 dec   temp
	 sts   uots,temp
u4:  sbrs  flag,2
	 rjmp  u40
	 cbr   flag,1<<2
	 sbrs  flag,3
     rjmp  PC+14
     ldi   temp,0
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 lds   uexl,implo
	 lds   uexh,imphi
	 sts   imphi,zero
	 sts   implo,zero
     rjmp  u43
	 sbr   flag,1<<3
     ldi   temp,100
	 sts   uots,temp
u40: rcall comp_low
	 brcc  u41
     ldi   temp,50
	 cbr   flag,1<<5 ;  
	 sbr   flag,1<<6
	 movw  uexl,ulo
	 rjmp  u43
u41: rcall comp_hi
	 brcc  u42
     ldi   temp,0
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 movw  uexl,ulo
     rjmp  u43
u42: clr   con
	 cbr   flag,1<<0
	 cbr   flag,(1<<5)|(1<<6)
	 ret
u43: inc   con
     cp    temp,con
     brcc  u44
	 clr   con
	 sbr   flag,1<<0
	 sts   fsave,flag
     ret
u44: cbr   flag,(1<<5)|(1<<6)
     ret

umod5:                 ; - 0   - 0,   
     lds   temp,uots
	 tst   temp
	 brne  PC+3
     cbr   flag,1<<3
     rjmp  u5
	 dec   temp
	 sts   uots,temp
u5:  sbrs  flag,2
	 rjmp  u50
	 cbr   flag,1<<2
	 sbrs  flag,3
     rjmp  PC+13
     ldi   temp,0
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 lds   uexl,implo
	 lds   uexh,imphi
	 sts   imphi,zero
	 sts   implo,zero
     rjmp  u53
	 sbr   flag,1<<3
     ldi   temp,100
	 sts   uots,temp
u50: rcall comp_low
	 brcc  u51
     ldi   temp,0
	 cbr   flag,1<<5 ;  
	 sbr   flag,1<<6
	 movw  uexl,ulo
	 rjmp  u53
u51: rcall comp_hi
	 brcc  u52
     ldi   temp,0
	 sbr   flag,1<<5 ;  
	 cbr   flag,1<<6
	 movw  uexl,ulo
     rjmp  u53
u52: clr   con
	 cbr   flag,1<<0
	 cbr   flag,(1<<5)|(1<<6)
	 ret
u53: inc   con
     cp    temp,con
     brcc  u54
	 clr   con
	 sbr   flag,1<<0
	 sts   fsave,flag
     ret
u54: cbr   flag,(1<<5)|(1<<6)
     ret


volt_ust:
	 sbrs  flag,0
	 rjmp  vu3
	 rcall pover_off
	 cbr   flag,1<<0
	 rcall load_del
	 lds   temp,indcon
	 cbr   temp,0b11110111
	 ldi   temp1,0b01000111
	 cpse  picter,zero
     cbr   temp1,0
	 or    temp,temp1
	 sts   indcon,temp
     cpi   picter,11
	 brcs  vu2
	 cpi   picter,16
	 breq  vu2
	 clr   picter
	 movw  wrdlo,ulo
	 rcall bin_dec
	 rcall save_sta
vu2: ret
vu3: mov   temp,delhi
     or    temp,dello
	 brne  vu7
	 lds   temp,indcon
	 cbr   temp,0b11110111
	 sts   indcon,temp
     rcall pover_on 
	 lds   temp,fsave
	 sbrs  temp,6
	 rjmp  vu5
	 sts   fsave,zero
	 lds   temp,locnt
	 cpi   temp,99
	 breq  vu4
	 inc   temp
	 sts   locnt,temp
     rcall save_sta
	 rcall save_err
vu4: ret
vu5: lds   temp,fsave
	 sbrs  temp,5
	 ret
	 sts   fsave,zero
     lds   temp,hicnt
	 cpi   temp,99
	 breq  vu6
	 inc   temp
	 sts   hicnt,temp  
     rcall save_sta
	 rcall save_err
vu6: ret
vu7: sbiw  delhi:dello,1
     rcall pover_off 
	 lds   temp,indcon
	 cbr   temp,0b11110111
	 ldi   temp1,0b10000111
	 cpse  picter,zero
     cbr   temp1,0
	 or    temp,temp1
	 sts   indcon,temp
	 ret

comp_hi: 
     clr   temp1       ; uhi:ulo > uh+220,  C=1 
     ldi   temp,220
     add   temp,uh
	 rol   temp1
     cp    temp,ulo
     cpc   temp1,uhi
	 ret

comp_low:
     cp    ulo,ul      ; uhi:ulo < ul,  C=1
	 cpc   uhi,zero
	 ret

load_del:
     push  R1
	 push  R0
	 ldi   temp,50
	 mul   dtlo,temp
     movw  dello,R0
     mul   dthi,temp
     add   delhi,R0 
	 pop   R0
	 pop   R1
	 ret

del100uS:
     push  wrdhi
	 push  wrdlo
	 ldi   wrdhi,high(200) 
     ldi   wrdlo,low(200)
	 sbiw  wrdhi:wrdlo,1
	 brne  PC-1
	 pop   wrdlo
	 pop   wrdhi
	 ret

del10mS:
     push  wrdhi
	 push  wrdlo
	 ldi   wrdhi,high(100) 
     ldi   wrdlo,low(100)
     rcall del100uS
	 sbiw  wrdhi:wrdlo,1
	 brne  PC-2
	 pop   wrdlo
	 pop   wrdhi
	 ret

convert:
     ldi   ZH,high(2*led_tabl)
     ldi   ZL,low(2*led_tabl)
	 lsl   temp
	 inc   temp
     add   ZL,temp
     adc   ZH,zero
     lpm   temp,Z
	 ldi   ZL,182
	 out   OCR2,ZL
	 in    temp1,PORTC
	 andi  temp1,0xF0
     push  temp
     andi  temp,0x0F
	 or    temp1,temp
	 pop   temp
	 in    temp2,PORTD
     andi  temp2,0x0F
     andi  temp,0xF0
	 or    temp2,temp
     ret  
	
bin_dec:
     push  temp
	 push  temp1
	 push  temp2
     push  wrdhi
     push  wrdlo
	 lds   temp2,blncon
     clr   temp
     subi  wrdlo,low(100)
	 sbci  wrdhi,high(100)
	 inc   temp
	 brcc  PC-3
	 subi  wrdlo,low(-100)
	 sbci  wrdhi,high(-100)
	 dec   temp
	 sbrc  temp2,0
	 rjmp  PC+3
	 brne  PC+2
	 ldi   temp,10
 	 sts   ind2,temp
	 lds   temp,ind2
     clr   temp1
     sbiw  wrdhi:wrdlo,10
	 inc   temp1
	 brcc  PC-2
     adiw  wrdhi:wrdlo,10
     dec   temp1
	 sbrc  temp2,0
	 rjmp  PC+5
	 brne  PC+4
	 cpi   temp,10
	 brne  PC+2
     ldi   temp1,10
	 sts   ind1,temp1
	 sts   ind0,wrdlo
     pop   wrdlo
     pop   wrdhi
	 pop   temp2
	 pop   temp1
	 pop   temp
	 ret   
	 
cor_volt:
     push  temp
	 push  R0
	 push  R1
     push  wrdhi
     push  wrdlo
     mul   ulo,kfl
	 movw  wrdlo,R0
     mul   uhi,kfh
	 mov   temp,R0
	 mul   uhi,kfl
	 add   wrdhi,R0
	 adc   temp,R1
	 mul   ulo,kfh
	 add   wrdhi,R0
	 adc   temp,R1
	 mov   wrdlo,wrdhi
     mov   wrdhi,temp
	 lsr   wrdhi
     ror   wrdlo
     lsr   wrdhi
     ror   wrdlo
     movw  ulo,wrdlo
     pop   wrdlo
     pop   wrdhi
	 pop   R1
	 pop   R0
	 pop   temp
	 ret 
     
pover_off:
     cbi   PORTIO,POV
     ret

pover_on:
     sbrc  umod,7
	 ret
     sbi   PORTIO,POV 
     clr   sumhi
     clr   sumlo
     clr   evrg
	 sts   implo,zero
	 sts   imphi,zero
     ret

save_err:
   #ifdef __COMMON_CATHODE__
	 sbi   PORTB,X0
	 sbi   PORTB,X1
	 sbi   PORTB,X2
   #else
     cbi   PORTB,X0
	 cbi   PORTB,X1
   	 cbi   PORTB,X2
   #endif
   	 in    temp,TIMSK
     cbr   temp,1<<OCIE1A
     out   TIMSK,temp 
	 movw  wrdlo,uexl
	 cpi   wrdlo,low(401) 
	 ldi   temp,high(401)
	 cpc   wrdhi,temp
	 brcs  PC+5
	 ldi   temp,low(400)
	 mov   uexl,temp
	 ldi   temp,high(400)
	 mov   uexh,temp
	 mov   temp,uexh
	 ldi   wrdhi,high(_uexh)  
     ldi   wrdlo,low(_uexh)   
     rcall ee_write_check
	 mov   temp,uexl
	 ldi   wrdhi,high(_uexl)  
     ldi   wrdlo,low(_uexl)   
     rcall ee_write_check
	 clr   sumlo
     clr   evrg
	 sts   implo,zero
	 sts   imphi,zero
	 in    temp,TIMSK
     sbr   temp,1<<OCIE1A
     out   TIMSK,temp 
	 ret
          
led_tabl:
 
 #ifdef __COMMON_CATHODE__ 
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A)         ; 0      0
 .db 0,0|(SEG_C)|(SEG_B)                                         ; 1      1
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)|(SEG_B)|(SEG_A)                 ; 2      2
 .db 0,0|(SEG_G)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A)                 ; 3      3
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_C)|(SEG_B)                         ; 4      4
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_A)                 ; 5      5
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_A)         ; 6      6
 .db 0,0|(SEG_C)|(SEG_B)|(SEG_A)                                 ; 7      7
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A) ; 8      8
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A)         ; 9      9
 .db 0,0                                                         ; space 10
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_C)|(SEG_B)|(SEG_A)                 ;      11
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_B)|(SEG_A)                 ; P     12
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_A)                 ; E     13
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_C)|(SEG_B)                 ;      14
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_C)|(SEG_B)|(SEG_A)         ;      5
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_B)                 ;      16
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_A)                         ; C     17
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)|(SEG_C)                         ; o     18
 .db 0,0|(SEG_D)                                                 ; _     19
 .db 0,0|(SEG_A)                                                 ; ~     20
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_C)|(SEG_B)                         ;      21
 .db 0,0|(SEG_G)                                                 ; -     22
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_A)                                 ;      23
 #else
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)$(SEG_B)$(SEG_A)         ; 0      0
 .db 0,0xFF&(SEG_C)&(SEG_B)                                         ; 1      1
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)&(SEG_B)&(SEG_A)                 ; 2      2
 .db 0,0xFF&(SEG_G)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A)                 ; 3      3
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_C)&(SEG_B)                         ; 4      4
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_A)                 ; 5      5
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_A)         ; 6      6
 .db 0,0xFF&(SEG_C)&(SEG_B)&(SEG_A)                                 ; 7      7
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A) ; 8      8
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A)         ; 9      9
 .db 0,0xFF                                                         ; space 10
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_C)&(SEG_B)&(SEG_A)                 ;      11
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_B)&(SEG_A)                 ; P     12
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_A)                 ; E     13
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_C)&(SEG_B)                 ;      14
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_C)&(SEG_B)&(SEG_A)         ;      5
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_B)                 ;      16
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_A)                         ; C     17
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)&(SEG_C)                         ; o     18
 .db 0,0xFF&(SEG_D)                                                 ; _     19
 .db 0,0xFF&(SEG_A)                                                 ; ~     20
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_C)&(SEG_B)                         ;      21
 .db 0,0xFF&(SEG_G)                                                 ; -     22
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_A)                                 ;      23
 #endif
